<?php
defined('_JEXEC') or die;
/**
 * @package    miniOrange
 * @subpackage Plugins
 * @license    GNU/GPLv3
 * @copyright  Copyright 2015 miniOrange. All Rights Reserved.
 *
 * miniOrange 2FA Plugin
 */
class plgauthenticationminiorangeauthtfa extends JPlugin
{
	/**
    * This method should handle any authentication and report back to the subject
	* 
	*
	* @access    public
	* @param     array     $credentials    Array holding the user credentials ('username' and 'password')
	* @param     array     $options        Array of extra options
	* @param     object    $response       Authentication response object
	* @return    boolean
	*/
	function onUserAuthenticate( $credentials, $options, &$response )
	{
        $post = JFactory::getApplication()->input->post->getArray();
		$licenseUtility = commonUtilitiesTfa::license_efficiency_check();
        $settings = commonUtilitiesTfa::getTfaSettings();
        $username=$post['username'];
                
        $login_with_second_factor_only = $settings['login_with_second_factor_only'] ? $settings['login_with_second_factor_only'] : 0;
		if(isset($licenseUtility['license_expiry']) && $licenseUtility['license_expiry']==1||isset($licenseUtility['users']) && $licenseUtility['users']==1||isset($licenseAttributes['plan_fetched']) && $licenseAttributes['plan_fetched'] == 1)
		{ 
			$app = JFactory::getApplication();
			$response->status = JAuthentication::STATUS_FAILURE;
            $app->enqueueMessage('Not able to configure the 2FA for your account. Please contact administrator', 'warning');
            $app->redirect(JURI::root());
            return false;
		}

        if(isset($post['Submit']) && ($post['Submit']=='') && $post['password']=='password')
        {
            if($username != ''){
                $result = commonUtilitiesTfa::get_user_from_joomla($post['username']);
                if($result){
                    $response->status = JAuthentication::STATUS_SUCCESS;
                    $response->error_message = '';
                    return true;
                }
                $response->status        = JAuthentication::STATUS_FAILURE;
                $response->error_message = JText::_('PLG_AUTHENTICATION_MINIORANGETFA_ERROR_MSG');
                return false;
            }
            
        }

        if($login_with_second_factor_only)
        {
            $username = isset($credentials['username']) ? $credentials['username'] : '';
            if($username != ''){
                $result = commonUtilitiesTfa::get_user_from_joomla($username);
                if($result){
                    $response->status = JAuthentication::STATUS_SUCCESS;
                    $response->error_message = '';
                    return true;
                }
                $response->status        = JAuthentication::STATUS_FAILURE;
                $response->error_message = JText::_('PLG_AUTHENTICATION_MINIORANGETFA_ERROR_MSG');
                return false;
            }
        }
	}
}
